import 'package:flutter/material.dart';

import 'package:arch_foundations/arch/bloc.dart';

class BlocProvider extends StatefulWidget {
  final Widget child;
  final List<Bloc> blocs;

  BlocProvider({
    Key key,
    @required this.child,
    @required this.blocs,
  });

  @override
  _BlocProviderState createState() => _BlocProviderState();

  static B of<B extends Bloc>(BuildContext context) {
    BlocProvider provider = context.ancestorWidgetOfExactType(BlocProvider);
    final results = provider.blocs.whereType<B>();
    if (results.isEmpty) {
      throw UnimplementedError(
        'No BLoC found for type $B. Are you sure you added an '
        'instance to your BlocProvider?',
      );
    }
    return results.first;
  }
}

class _BlocProviderState extends State<BlocProvider> {
  @override
  Widget build(BuildContext context) {
    return widget.child;
  }

  @override
  void dispose() {
    widget.blocs.forEach((it) => it.dispose());
    super.dispose();
  }
}
