import 'package:flutter/material.dart';

import 'snackbarer.dart';

mixin SnackBarErMixin implements SnackBarEr {
  final scaffoldKey = GlobalKey<ScaffoldState>();

  @override
  void showSnackBar(String text, [SnackBarAction action]) {
    WidgetsBinding.instance.addPostFrameCallback((_) {
      scaffoldKey.currentState.hideCurrentSnackBar();
      scaffoldKey.currentState.showSnackBar(
        SnackBar(
          content: Text(text ?? '?'),
          action: action,
        ),
      );
    });
  }
}
