import 'package:arch_foundations/arch/bloc.dart';
import 'package:bloc_event_gen/bloc_event_gen.dart';
import 'package:flutter/widgets.dart';
import 'package:flutter_test/flutter_test.dart';

import '../test_utils.dart';

class _TestBloc extends Bloc {}

class _TestEvent extends BlocEvent {}

void main() {
  group(nameOf(Bloc), () {
    test('correctly dispatches UI events', () {
      final bloc = _TestBloc();
      expect(bloc.uiEvents, emits(TypeMatcher<_TestEvent>()));
      bloc.dispatchUiEvent(_TestEvent());
    });

    test(
      'calling dispose closes the UI events stream',
      () {
        final bloc = _TestBloc();
        expect(bloc.uiEvents, emitsDone);
        bloc.dispose();
      },
      timeout: Timeout(Duration(seconds: 2)),
    );
  });
}
